#include <stdint.h>
#include "M6502.h"

__declspec(dllexport) uint32_t mod_type=0x32303536;
__declspec(dllexport) uint8_t *mod_name="M65C02";
__declspec(dllexport) uint8_t *mod_pref="M65C02";
__declspec(dllexport) uint8_t *mod_vers="1.4";
__declspec(dllexport) uint8_t *mod_copr="Copyright (C) Marat Fayzullin 1996-2002\n"
                                        "              Alex Krasivsky  1996\n"
                                        "              Steve Nickolas  2002, 2017";

M6502 CPU;

void (*cpuwrite)(uint16_t, uint8_t);
uint8_t (*cpuread)(uint16_t);
int8_t (*cpuloop)(uint32_t);

void Wr6502(register word Addr,register byte Value)
{
 cpuwrite(Addr,Value);
}

byte Rd6502(register word Addr)
{
 return cpuread(Addr);
}

byte Loop6502(register M6502 *R)
{
 int x;
 
 x=cpuloop(R->ICount);
 
 if (x==-1) return INT_QUIT;
}

__declspec(dllexport) void M65C02_cpureset(void)
{
 Reset6502(&CPU);
}

__declspec(dllexport) void M65C02_cpurun(void)
{
 Run6502(&CPU);
}

__declspec(dllexport) void M65C02_cpuseta(uint8_t val)
{
 CPU.A=val;
}

__declspec(dllexport) void M65C02_cpusetx(uint8_t val)
{
 CPU.X=val;
}

__declspec(dllexport) void M65C02_cpusety(uint8_t val)
{
 CPU.Y=val;
}

__declspec(dllexport) void M65C02_cpusets(uint8_t val)
{
 CPU.S=val;
}

__declspec(dllexport) void M65C02_cpusetp(uint8_t val)
{
 CPU.P=val;
}

__declspec(dllexport) void M65C02_cpusetpc(uint16_t val)
{
 CPU.PC.W=val;
}

__declspec(dllexport) void M65C02_cpusetrate(int val)
{
 CPU.IPeriod=val;
}

__declspec(dllexport) uint8_t M65C02_cpugeta(void)
{
 return CPU.A;
}

__declspec(dllexport) uint8_t M65C02_cpugetx(void)
{
 return CPU.X;
}

__declspec(dllexport) uint8_t M65C02_cpugety(void)
{
 return CPU.Y;
}

__declspec(dllexport) uint8_t M65C02_cpugets(void)
{
 return CPU.S;
}

__declspec(dllexport) uint8_t M65C02_cpugetp(void)
{
 return CPU.P;
}

__declspec(dllexport) uint16_t M65C02_cpugetpc(void)
{
 return CPU.PC.W;
}

__declspec(dllexport) int M65C02_cpugetrate(void)
{
 return CPU.IPeriod;
}

__declspec(dllexport) int M65C02_cpugetcycles(void)
{
 return CPU.ICount;
}

__declspec(dllexport) void M65C02_cpuinit(void (*v_cpuwrite)(uint16_t, uint8_t),
                                          uint8_t (*v_cpuread)(uint16_t),
                                          int8_t (*v_cpuloop)(uint32_t))
{
 cpuwrite=v_cpuwrite;
 cpuread=v_cpuread;
 cpuloop=v_cpuloop;
}
